---
title: Document.createExpression()
slug: Web/API/Document/createExpression
tags:
  - API
  - DOM
  - Method
  - Reference
  - XPath
  - createExpression
---
<div>{{APIRef("DOM")}}</div>

<p>This method compiles an {{DOMxRef("XPathExpression")}} which can then be used for (repeated) evaluations.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>xpathExpr</var> = <var>document</var>.createExpression(<var>xpathText</var>, <var>namespaceURLMapper</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<ul>
 <li><var>xpathText</var> is a string which is the XPath expression to be compiled.</li>
 <li><var>namespaceURLMapper</var> is a function which maps a namespace prefix to a namespace URL (or null if none needed).</li>
</ul>

<p>{{Fx_MinVersion_Note(3, "Prior to Firefox 3, you could call this method on documents other than the one you planned to run the XPath against. Under Firefox 3, you must call it on the same document.")}}</p>

<h3 id="Return_value">Return value</h3>

<p>{{DOMxRef("XPathExpression")}}</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.createExpression")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("Document.evaluate()")}}</li>
 <li>{{DOMxRef("XPathExpression")}}</li>
</ul>
